NXOpen .NET Reference Guide  1899
 All Classes Namespaces Functions Variables Enumerations Enumerator Properties
Public Types | Public Member Functions | Properties | List of all members
NXOpen.Routing.SplinePathBuilder Class Reference

Represents a NXOpen.Routing.SplinePathBuilder object. More...

Inheritance diagram for NXOpen.Routing.SplinePathBuilder:
NXOpen.Builder NXOpen.TaggedObject NXOpen.GeometricUtilities.IComponentBuilder NXOpen.Utilities.NXRemotableObject IMessageSink

Public Types

enum  DefiningPointMethod { CreatePoint, UseExisting }
 Specifies if a new point should be created when adding a point to the spline. More...
 
enum  DefiningTypes {
  Unsupported, Interpolation, Parametric, Bezier,
  BezierSlack, BezierMaxCurvature, BezierMaxCurvatureSlacked
}
 Specifies how the spline points define the shape of the spline. More...
 
enum  DragMode { Active, Inactive }
 Specifies if drag network is active when updating the position of a defining point. More...
 
enum  SplinePathAttributeOptions { Radius, RatioToDiameter }
 Describes user attribute methods options. More...
 
enum  SplinePathRadiusSource { Expression, RatioToDiameter, Attribute }
 Describes the method for the constrained curvature spline to be defined as. More...
 
enum  SplinePathSlackType {
  PercentLength, AdditionalLength, LockLength, TotalPercentage,
  TotalAdditional, Undefined
}
 Describes the type of slack to be applied to the spline. More...
 

Public Member Functions

unsafe void AddDefiningPointAtAbsoluteCoords (NXOpen.Point3d point)
 Adds a point to the spline. More...
 
unsafe int AddDefiningPointToSpline (NXOpen.Point point, bool createNewPoint)
 Adds a defining point to the current spline or creates the first point of the new spline. More...
 
unsafe void AddSlackToSpline (NXOpen.Routing.SplinePathBuilder.SplinePathSlackType slackType, NXOpen.Expression slackValue, NXOpen.Direction slackDirection)
  More...
 
unsafe void AskDefiningData (out NXOpen.Point[] points)
 When a spline is selected for editing, the builder will analyze the spline and gather all of the defining data. More...
 
unsafe void AssignExtension (int pointIndex, NXOpen.Direction direction, NXOpen.Expression forwardLength, NXOpen.Expression backwardLength)
 Assigns an extension to the point at pointIndex. More...
 
unsafe void AssignExtension (int pointIndex, NXOpen.Direction direction, NXOpen.Expression forwardLength, NXOpen.Expression backwardLength, bool forceDeleteOnZeroExpression)
 Assigns an extension to the point at pointIndex. More...
 
unsafe void AssignHealPathExtension (int pointIndex, NXOpen.Direction direction, NXOpen.Expression forwardLength, NXOpen.Expression backwardLength)
 Assigns an extension to the point at pointIndex for Heal Path. More...
 
unsafe void AssignTangentExtensionForPointAtIndex (int index, NXOpen.Expression forwardLength, NXOpen.Expression backwardLength, out NXOpen.Vector3d tangent, out NXOpen.Vector3d normal, out NXOpen.Direction extensionDir)
 Assigns the extension direction and expressions tangent to the spline path at the given point index. More...
 
unsafe NXOpen.Routing.Stock BlankStockAndGetLargestDia ()
 Blanks all the stocks on the current segment and returns the stock with the largest diameter. More...
 
unsafe void CommitDrag (NXOpen.Point definingPoint)
 Clears the current drag network. More...
 
unsafe
NXOpen.Routing.AssignTangencyBuilder 
CreateAssignTangencyBuilder ()
 Creates a NXOpen.Routing.AssignTangencyBuilder object. More...
 
unsafe void CreateHealPathConstraints (NXOpen.NXObject startObject, NXOpen.NXObject endObject)
 Creates constraints between the start and end objects passed in to the spline. More...
 
unsafe void DeleteDefiningPointAtIndex (int index)
 Deletes a defining point from the spline. More...
 
unsafe void DetachPoint (int index)
 Detaches the point at the selected index from all objects its attached to using a Touch constraint. More...
 
unsafe
NXOpen.Routing.AssignTangencyBuilder 
GetAssignTangencyBuilder ()
 Get a NXOpen.Routing.AssignTangencyBuilder object. More...
 
unsafe void GetDefiningPointPositions (out double[] pointPositions)
 Gets the positions of the defining points as an array of doubles. More...
 
unsafe void GetDefiningPointPositionsAsPoints (out NXOpen.Point3d[] pointPositions)
 Gets the positions of the defining points as an array of Point3d coordinates. More...
 
unsafe void GetExtensionDataForPointAtIndex (int index, out NXOpen.Expression forwardLength, out NXOpen.Expression backwardLength, out NXOpen.Vector3d extDirection)
 Get the extension expressions at the given index. More...
 
unsafe NXOpen.Routing.Stock GetLargestDiameterStock ()
 Returns the stock with the largest on the current segment. More...
 
unsafe double GetLockedSplineMinimumLength ()
 Returns the minimum length of the spline. More...
 
unsafe void GetOffsetData (int index, out int method, out NXOpen.Point basePoint, out NXOpen.Direction offDir, out string exp)
 Returns the Stock Offset data associated with a given point. More...
 
unsafe NXOpen.Curve GetRouteSegment ()
 Gets the routing segment managed by the builder, if it exists. More...
 
unsafe double GetSplineLength ()
 Gets the current length of the spline. More...
 
unsafe double GetSplineLengthNoShaping ()
 Gets the current length of the spline without shaping applied. More...
 
unsafe NXOpen.Routing.ControlPoint GetStartAndEndRcp (out NXOpen.Routing.ControlPoint startRcp)
 Gets the RCPs managed by the builder, if they exist. More...
 
unsafe void InitializeDrag (int index)
 Initialize the D-Cubed dragging functionality for the point at index. More...
 
unsafe void IsLengthLocked (out NXOpen.Expression length, out bool isLocked, out NXOpen.Direction slackDirection)
 Is the spline length locked? More...
 
unsafe void IsSplineSlacked (out bool slacked, out NXOpen.Routing.SplinePathBuilder.SplinePathSlackType slackType, out NXOpen.Expression slackValue, out NXOpen.Direction downDir)
  More...
 
unsafe void LockSplineLengthNoShaping (NXOpen.Expression length)
 Locks the length of the current spline. More...
 
unsafe void LockSplineLengthWithShaping (NXOpen.Expression length, NXOpen.Direction slackDirection)
 Locks the length of the current spline. More...
 
unsafe void LockSplineLengthWithShapingFixedPoints (NXOpen.Expression length, NXOpen.Direction slackDirection)
 Locks the length of the current spline and fixes the interior points of the spline. More...
 
unsafe void RemoveAllShaping ()
 Removes all shaping applied to the spline (Lock length, slacking). More...
 
unsafe void RemoveLengthConstraint ()
 Removes the spline length constraint that makes the spline a locked length spline. More...
 
unsafe void SetAddPointsOnSubdivideFlag (bool addPoints)
 Sets whether or not additional points will be added to a spline which is created as the result of a subdivide. More...
 
unsafe void SetCreateTangencyFlag (bool createTangency)
 Sets whether or not additional the newly created spline will be made tangent to connecting splines. More...
 
unsafe void SetDefaultPortExtensionLength (double value)
 Sets the default port extension length to be used when creating or editing points at port locations that do not already have an extension . More...
 
unsafe void SetLockToSelectedFlag (bool lockSelected)
 Sets whether the spline will attempt to lock points to selected object. More...
 
unsafe void SetSplineMethod (NXOpen.Positioning.Constraint.SplineType splineMethod)
 Sets the defining method of the spline. More...
 
unsafe void SetStockBoundedDiameter (double value)
 Sets the driving diameter of the current stock for the ratio-to-diameter bounded curvature. More...
 
unsafe void ShapeByAdditionalLengthMovingPoints (NXOpen.Expression length, NXOpen.Routing.SplinePathBuilder.SplinePathSlackType slackType, NXOpen.Direction slackDirection)
 Adds slack to the spline without locking the length. More...
 
unsafe void UnblankStocks ()
 Unblanks stocks which were blanked by calling BlankStockAndGetLargestDia More...
 
unsafe void UpdateDefiningPoint (int index, NXOpen.Point point, bool inDrag, NXOpen.Vector3d translation)
 Updates the position of a point on the spline. More...
 
unsafe void UpdateDefiningPointPositionAtIndex (int index, NXOpen.Point point, bool inDrag)
 Updates the position of a point on the spline. More...
 
unsafe void UpdateExtensionDirectionAtIndex (int index, NXOpen.Vector3d direction)
 Update the extension orientation at the point index. More...
 
unsafe void UpdateExtensionDirectionForPointAtIndex (int index, NXOpen.Vector3d deltaTrans, NXOpen.Matrix3x3 orientation, bool inDrag)
 Update the extension orientation at the point index. More...
 
- Public Member Functions inherited from NXOpen.Builder
unsafe NXOpen.NXObject Commit ()
 Commits any edits that have been applied to the builder. More...
 
unsafe void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
unsafe NXOpen.NXObject[] GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
unsafe NXOpen.NXObject GetObject ()
 Returns the object currently being edited by this builder. More...
 
unsafe void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
unsafe bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen.TaggedObject
void PrintTestData (String variableName)
 <exclude> More...
 
void PrintTestData (String variableName, int lineNumber)
 <exclude> More...
 
override string ToString ()
 Returns a String that represents the current Object. More...
 
- Public Member Functions inherited from NXOpen.Utilities.NXRemotableObject
IMessageCtrl AsyncProcessMessage (IMessage msg, IMessageSink replySink)
 Asynchronously processes the given message. More...
 
IMessage SyncProcessMessage (IMessage msg)
 Synchronously processes the given message. More...
 

Properties

unsafe bool BoundedCurvature [get, set]
 Returns or sets whether the spline maximum bounded radius value should be used. More...
 
unsafe NXOpen.Expression BoundedCurvatureRadius [get]
 Returns the minimum radius allowed for this spline. More...
 
unsafe NXOpen.Expression BoundedCurvatureRatio [get]
 Returns the minimum radius allowed for this spline as a ratio to diameter. More...
 
unsafe
NXOpen.Routing.SplinePathBuilder.DefiningTypes 
DefiningType [get, set]
 Returns or sets the type which specifies the shape of the spline. More...
 
unsafe NXOpen.Expression MinimumCheckingAllowableRatio [get]
 Returns the minimum ratio allowed for this spline More...
 
unsafe NXOpen.Expression MinimumCheckingAllowableValue [get]
 Returns the minimum radius allowed for this spline. More...
 
unsafe
NXOpen.Routing.SplinePathBuilder.SplinePathAttributeOptions 
MinimumCheckingMethod [get, set]
 Returns or sets the minimum checking method for this spline. More...
 
unsafe
NXOpen.Routing.SplinePathBuilder.SplinePathRadiusSource 
RadiusSource [get, set]
 Returns or sets the driving expression, value, or attribute of the bounded radius. More...
 
unsafe bool ShowSplineMinimumRadius [get, set]
 Returns or sets whether the spline minimum radius value should be displayed or not. More...
 
unsafe bool UseMinimumCheckingValue [get, set]
 Returns or sets whether the spline minimum radius value should be checked or not on this spline. More...
 
- Properties inherited from NXOpen.Builder
unsafe NXOpen.PreviewBuilder PreviewBuilder [get]
 Returns the preview builder subobject. More...
 
- Properties inherited from NXOpen.TaggedObject
Tag Tag [get]
 Returns the tag of this object. More...
 
- Properties inherited from NXOpen.Utilities.NXRemotableObject
IMessageSink NextSink [get]
 Gets the next message sink in the sink chain. More...
 

Additional Inherited Members

- Protected Member Functions inherited from NXOpen.TaggedObject
new void initialize ()
 <exclude> More...
 

Detailed Description

Represents a NXOpen.Routing.SplinePathBuilder object.

The builder allows for creating and editing D-Cubed constrained splines, adding extensions, adding stock offset points, adding stock, locking length, adding slack, and locking to other D-Cubed constrained objects.

To create a new instance of this class, use NXOpen.Routing.RouteManager.CreateSplinePathBuilder

Created in NX6.0.0

Member Enumeration Documentation

Specifies if a new point should be created when adding a point to the spline.

Enumerator
CreatePoint 
UseExisting 

Specifies how the spline points define the shape of the spline.

Enumerator
Unsupported 

The defining type is unsupported.

Interpolation 

The defining type represents a C1-continuous, interpolation spline.

Parametric 

The defining type represents a G1-continuous, parametric curve.

Bezier 

The defining type represents a G1-continuous, piecewise cubic Bezier.

BezierSlack 

The defining type represents a G1-continuous, piecewise cubic Bezier with pseudo gravity slack.

BezierMaxCurvature 

The defining type represents a G1-continuous, piecewise cubic Bezier with bounded maximum curvature.

BezierMaxCurvatureSlacked 

The defining type represents a G1-continuous, piecewise cubic Bezier with bounded maximum curvature with pseudo gravity slack.

Specifies if drag network is active when updating the position of a defining point.

Enumerator
Active 

The drag network is active

Inactive 

The drag network is inactive

Describes user attribute methods options.

These value are used to set minimum checking method. If checking method is ratio to diameter than allowable radius will be computed by ratioToDiameter x Stock Diameter.

Enumerator
Radius 

A radius method option for spline user attribute

RatioToDiameter 

A ratio to diameter method option for spline user attribute.

Describes the method for the constrained curvature spline to be defined as.

Enumerator
Expression 

Specify radius by value.

RatioToDiameter 

Specify radius by ratio to stock.

Attribute 

Specify radius by attribute.

Describes the type of slack to be applied to the spline.

Enumerator
PercentLength 

The length of the spline is increased by a percentage of the spline length.

AdditionalLength 

The length of the spline is increased by an additional length.

LockLength 

The length of the spline is slacking to a specified and locked length.

TotalPercentage 

Slack value is ratio of extra length.

Non-end defining points relaxed down

TotalAdditional 

Slack value is extra length.

Non-end defining points relaxed down

Undefined 

Slack length is undefined.

Member Function Documentation

unsafe void NXOpen.Routing.SplinePathBuilder.AddDefiningPointAtAbsoluteCoords ( NXOpen.Point3d  point)
inline

Adds a point to the spline.

The point will be the new endpoint of the spline.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
pointThe Point to add.
unsafe int NXOpen.Routing.SplinePathBuilder.AddDefiningPointToSpline ( NXOpen.Point  point,
bool  createNewPoint 
)
inline

Adds a defining point to the current spline or creates the first point of the new spline.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
pointPoint to add.
createNewPointShould the builder create a new point based on the one provided?
Returns
Returns the index the point was added along the spline. For example, if 3 points exist on the spline and the new point was added between points 0 and 1 this variable would be set to 1.
unsafe void NXOpen.Routing.SplinePathBuilder.AddSlackToSpline ( NXOpen.Routing.SplinePathBuilder.SplinePathSlackType  slackType,
NXOpen.Expression  slackValue,
NXOpen.Direction  slackDirection 
)
inline

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
slackTypeThe type of slack to add.
slackValueThe amount of slack to add.
slackDirectionThe direction to apply slack.
unsafe void NXOpen.Routing.SplinePathBuilder.AskDefiningData ( out NXOpen.Point[]  points)
inline

When a spline is selected for editing, the builder will analyze the spline and gather all of the defining data.

The dialog will use this function to retrieve the defining data from the builder to populate its fields.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
pointsDefining points of the spline.
unsafe void NXOpen.Routing.SplinePathBuilder.AssignExtension ( int  pointIndex,
NXOpen.Direction  direction,
NXOpen.Expression  forwardLength,
NXOpen.Expression  backwardLength 
)
inline

Assigns an extension to the point at pointIndex.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
pointIndexIndex of the point to assing extension.
directionDirection of the extension.
forwardLengthForward Length of the extension.
backwardLengthBackward Length of the extension.
unsafe void NXOpen.Routing.SplinePathBuilder.AssignExtension ( int  pointIndex,
NXOpen.Direction  direction,
NXOpen.Expression  forwardLength,
NXOpen.Expression  backwardLength,
bool  forceDeleteOnZeroExpression 
)
inline

Assigns an extension to the point at pointIndex.

Created in NX11.0.1

License requirements: routing_base ("Routing Basic")

Parameters
pointIndexIndex of the point to assign extension.
directionDirection of extension.
forwardLengthForward length of extension.
backwardLengthBackward length of extension.
forceDeleteOnZeroExpression
unsafe void NXOpen.Routing.SplinePathBuilder.AssignHealPathExtension ( int  pointIndex,
NXOpen.Direction  direction,
NXOpen.Expression  forwardLength,
NXOpen.Expression  backwardLength 
)
inline

Assigns an extension to the point at pointIndex for Heal Path.

Created in NX6.0.1

License requirements: routing_base ("Routing Basic")

Parameters
pointIndexIndex of the point to assing extension.
directionDirection of the extension.
forwardLengthLength of the forward extension.
backwardLengthLength of the backward extension.
unsafe void NXOpen.Routing.SplinePathBuilder.AssignTangentExtensionForPointAtIndex ( int  index,
NXOpen.Expression  forwardLength,
NXOpen.Expression  backwardLength,
out NXOpen.Vector3d  tangent,
out NXOpen.Vector3d  normal,
out NXOpen.Direction  extensionDir 
)
inline

Assigns the extension direction and expressions tangent to the spline path at the given point index.

Created in NX11.0.1

License requirements: routing_base ("Routing Basic")

Parameters
indexIndex of the point to use.
forwardLengthLength of the forward extension.
backwardLengthLength of the backward extension.
tangentExtension direction.
normalCurve normal.
extensionDirDirection object.
unsafe NXOpen.Routing.Stock NXOpen.Routing.SplinePathBuilder.BlankStockAndGetLargestDia ( )
inline

Blanks all the stocks on the current segment and returns the stock with the largest diameter.

Created in NX7.5.1

Deprecated in NX12.0.0. Use Routing.SplinePathBuilder.GetLargestDiameterStock instead.

License requirements: routing_base ("Routing Basic")

Returns
The stock with the largest diameter.
unsafe void NXOpen.Routing.SplinePathBuilder.CommitDrag ( NXOpen.Point  definingPoint)
inline

Clears the current drag network.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
definingPointOptional UI point defining the position of the spline point.
unsafe NXOpen.Routing.AssignTangencyBuilder NXOpen.Routing.SplinePathBuilder.CreateAssignTangencyBuilder ( )
inline

Creates a NXOpen.Routing.AssignTangencyBuilder object.

Created in NX12.0.0

License requirements: routing_base ("Routing Basic")

Returns
unsafe void NXOpen.Routing.SplinePathBuilder.CreateHealPathConstraints ( NXOpen.NXObject  startObject,
NXOpen.NXObject  endObject 
)
inline

Creates constraints between the start and end objects passed in to the spline.

These constraints can include touch / align to the RCP and parallel to the spline extension.

Created in NX12.0.2

License requirements: routing_base ("Routing Basic")

Parameters
startObjectObject selected at start of path
endObjectObject selected at end of path
unsafe void NXOpen.Routing.SplinePathBuilder.DeleteDefiningPointAtIndex ( int  index)
inline

Deletes a defining point from the spline.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
indexIndex of the point to delete.
unsafe void NXOpen.Routing.SplinePathBuilder.DetachPoint ( int  index)
inline

Detaches the point at the selected index from all objects its attached to using a Touch constraint.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
indexIndex of point to detach.
unsafe NXOpen.Routing.AssignTangencyBuilder NXOpen.Routing.SplinePathBuilder.GetAssignTangencyBuilder ( )
inline

Get a NXOpen.Routing.AssignTangencyBuilder object.

Created in NX12.0.0

License requirements: routing_base ("Routing Basic")

Returns
unsafe void NXOpen.Routing.SplinePathBuilder.GetDefiningPointPositions ( out double[]  pointPositions)
inline

Gets the positions of the defining points as an array of doubles.

Each point's XYZ coordinates are represented by three doubles. X1, Y1, Z1, X2, Y2, Z2, X3, Y3, Z3, ...

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
pointPositionsarray of doubles representing the defining points.
unsafe void NXOpen.Routing.SplinePathBuilder.GetDefiningPointPositionsAsPoints ( out NXOpen.Point3d[]  pointPositions)
inline

Gets the positions of the defining points as an array of Point3d coordinates.

Created in NX11.0.2

License requirements: routing_base ("Routing Basic")

Parameters
pointPositionsarray of points representing the defining points.
unsafe void NXOpen.Routing.SplinePathBuilder.GetExtensionDataForPointAtIndex ( int  index,
out NXOpen.Expression  forwardLength,
out NXOpen.Expression  backwardLength,
out NXOpen.Vector3d  extDirection 
)
inline

Get the extension expressions at the given index.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
indexIndex of the defining point to query.
forwardLengthForward extension length.
backwardLengthBackward extension length.
extDirectionExtension direction.
unsafe NXOpen.Routing.Stock NXOpen.Routing.SplinePathBuilder.GetLargestDiameterStock ( )
inline

Returns the stock with the largest on the current segment.

Created in NX12.0.0

License requirements: routing_base ("Routing Basic")

Returns
The stock with the largest diameter.
unsafe double NXOpen.Routing.SplinePathBuilder.GetLockedSplineMinimumLength ( )
inline

Returns the minimum length of the spline.

The minimum length is the straight line distance between all defining points, including extensions.

Created in NX7.5.4

License requirements: routing_base ("Routing Basic")

Returns
The minimum length of the spline.
unsafe void NXOpen.Routing.SplinePathBuilder.GetOffsetData ( int  index,
out int  method,
out NXOpen.Point  basePoint,
out NXOpen.Direction  offDir,
out string  exp 
)
inline

Returns the Stock Offset data associated with a given point.

Output can be NULL if the associated point is not a stock offset point.

Created in NX6.0.1

License requirements: routing_base ("Routing Basic")

Parameters
indexIndex of point to detach.
methodThe type of offset object. 0 = Not Offset, 1 = Stock Offset Point, 2 = Stock Offset Surface.
basePointThe base point frim the offset object.
offDirThe offset direction.
expThe expression defining the offset distance.
unsafe NXOpen.Curve NXOpen.Routing.SplinePathBuilder.GetRouteSegment ( )
inline

Gets the routing segment managed by the builder, if it exists.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Returns
Visible Routing BCurve Segment.
unsafe double NXOpen.Routing.SplinePathBuilder.GetSplineLength ( )
inline

Gets the current length of the spline.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Returns
The length of the current spline.
unsafe double NXOpen.Routing.SplinePathBuilder.GetSplineLengthNoShaping ( )
inline

Gets the current length of the spline without shaping applied.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Returns
The length of the current spline without shaping.
unsafe NXOpen.Routing.ControlPoint NXOpen.Routing.SplinePathBuilder.GetStartAndEndRcp ( out NXOpen.Routing.ControlPoint  startRcp)
inline

Gets the RCPs managed by the builder, if they exist.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
startRcpThe source ControlPoint.
Returns
The target ControlPoint.
unsafe void NXOpen.Routing.SplinePathBuilder.InitializeDrag ( int  index)
inline

Initialize the D-Cubed dragging functionality for the point at index.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
indexIndex of the point to drag.
unsafe void NXOpen.Routing.SplinePathBuilder.IsLengthLocked ( out NXOpen.Expression  length,
out bool  isLocked,
out NXOpen.Direction  slackDirection 
)
inline

Is the spline length locked?

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
lengthThe locked length of the spline.
isLockedIs the spline length locked?
slackDirectionThe direction to apply slack.
unsafe void NXOpen.Routing.SplinePathBuilder.IsSplineSlacked ( out bool  slacked,
out NXOpen.Routing.SplinePathBuilder.SplinePathSlackType  slackType,
out NXOpen.Expression  slackValue,
out NXOpen.Direction  downDir 
)
inline

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
slackedIs slack applied to the spline?
slackTypeThe type of slack.
slackValueThe added amount of slack.
downDirThe slack direction.
unsafe void NXOpen.Routing.SplinePathBuilder.LockSplineLengthNoShaping ( NXOpen.Expression  length)
inline

Locks the length of the current spline.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
lengthThe length to lock the spline.
unsafe void NXOpen.Routing.SplinePathBuilder.LockSplineLengthWithShaping ( NXOpen.Expression  length,
NXOpen.Direction  slackDirection 
)
inline

Locks the length of the current spline.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
lengthThe length to lock the spline.
slackDirectionThe direction to apply slack.
unsafe void NXOpen.Routing.SplinePathBuilder.LockSplineLengthWithShapingFixedPoints ( NXOpen.Expression  length,
NXOpen.Direction  slackDirection 
)
inline

Locks the length of the current spline and fixes the interior points of the spline.

Created in NX1847.0.0

License requirements: routing_base ("Routing Basic")

Parameters
lengthThe length to lock the spline.
slackDirectionThe direction to apply slack.
unsafe void NXOpen.Routing.SplinePathBuilder.RemoveAllShaping ( )
inline

Removes all shaping applied to the spline (Lock length, slacking).

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

unsafe void NXOpen.Routing.SplinePathBuilder.RemoveLengthConstraint ( )
inline

Removes the spline length constraint that makes the spline a locked length spline.

Created in NX1847.0.0

License requirements: routing_base ("Routing Basic")

unsafe void NXOpen.Routing.SplinePathBuilder.SetAddPointsOnSubdivideFlag ( bool  addPoints)
inline

Sets whether or not additional points will be added to a spline which is created as the result of a subdivide.

If true, new points will be added to maintain a shape similar to the original curve.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
addPointsTrue to add points to subdivided splines.
unsafe void NXOpen.Routing.SplinePathBuilder.SetCreateTangencyFlag ( bool  createTangency)
inline

Sets whether or not additional the newly created spline will be made tangent to connecting splines.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
createTangencyTrue to add tangency.
unsafe void NXOpen.Routing.SplinePathBuilder.SetDefaultPortExtensionLength ( double  value)
inline

Sets the default port extension length to be used when creating or editing points at port locations that do not already have an extension .

Created in NX12.0.0

License requirements: routing_advanced ("Routing Advanced")

Parameters
value
unsafe void NXOpen.Routing.SplinePathBuilder.SetLockToSelectedFlag ( bool  lockSelected)
inline

Sets whether the spline will attempt to lock points to selected object.

This flag is only checked when adding a point to a spline by passing in a smart point to derive a new dumb spline point from. If the smart point is derived from a Port, ControlPoint, or other Routing Object, the new spline defining point will lock to that object. This flag is also checked during commit, where endpoint associativity is applied.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
lockSelectedTrue to lock to selected objects.
unsafe void NXOpen.Routing.SplinePathBuilder.SetSplineMethod ( NXOpen.Positioning.Constraint.SplineType  splineMethod)
inline

Sets the defining method of the spline.

Created in NX6.0.0

Deprecated in NX11.0.2. Use Routing.SplinePathBuilder.DefiningTypes instead.

License requirements: routing_base ("Routing Basic")

Parameters
splineMethodthe defining method of the spline.
unsafe void NXOpen.Routing.SplinePathBuilder.SetStockBoundedDiameter ( double  value)
inline

Sets the driving diameter of the current stock for the ratio-to-diameter bounded curvature.

Created in NX12.0.0

License requirements: routing_advanced ("Routing Advanced")

Parameters
value
unsafe void NXOpen.Routing.SplinePathBuilder.ShapeByAdditionalLengthMovingPoints ( NXOpen.Expression  length,
NXOpen.Routing.SplinePathBuilder.SplinePathSlackType  slackType,
NXOpen.Direction  slackDirection 
)
inline

Adds slack to the spline without locking the length.

This will move the interior defining points of the spline in the slack direction until the given length is reached.

Created in NX12.0.2

License requirements: routing_base ("Routing Basic")

Parameters
lengthThe length of the spline.
slackTypeThe type of slack.
slackDirectionThe direction to apply slack.
unsafe void NXOpen.Routing.SplinePathBuilder.UnblankStocks ( )
inline

Unblanks stocks which were blanked by calling BlankStockAndGetLargestDia

Created in NX7.5.1

Deprecated in NX12.0.0. There is no need for this method.

License requirements: routing_base ("Routing Basic")

unsafe void NXOpen.Routing.SplinePathBuilder.UpdateDefiningPoint ( int  index,
NXOpen.Point  point,
bool  inDrag,
NXOpen.Vector3d  translation 
)
inline

Updates the position of a point on the spline.

Created in NX12.0.0

License requirements: routing_base ("Routing Basic")

Parameters
indexThe index of the point to update position..
pointThe point representing the new position.
inDragIs the point currently being dragged?
translationTranslation to redefine the point.
unsafe void NXOpen.Routing.SplinePathBuilder.UpdateDefiningPointPositionAtIndex ( int  index,
NXOpen.Point  point,
bool  inDrag 
)
inline

Updates the position of a point on the spline.

Created in NX6.0.0

License requirements: routing_base ("Routing Basic")

Parameters
indexThe index of the point to update position..
pointThe point representing the new position.
inDragIs the point currently being dragged?
unsafe void NXOpen.Routing.SplinePathBuilder.UpdateExtensionDirectionAtIndex ( int  index,
NXOpen.Vector3d  direction 
)
inline

Update the extension orientation at the point index.

Created in NX12.0.0

License requirements: routing_base ("Routing Basic")

Parameters
indexIndex of the point to analyze.
directionDirection to assign the extension.
unsafe void NXOpen.Routing.SplinePathBuilder.UpdateExtensionDirectionForPointAtIndex ( int  index,
NXOpen.Vector3d  deltaTrans,
NXOpen.Matrix3x3  orientation,
bool  inDrag 
)
inline

Update the extension orientation at the point index.

Created in NX11.0.1

License requirements: routing_base ("Routing Basic")

Parameters
indexIndex of the point to analyze.
deltaTransTranslation to transform.
orientationDelta rotation transform.
inDragthe geometry is currently being dragged?

Property Documentation

unsafe bool NXOpen.Routing.SplinePathBuilder.BoundedCurvature
getset

Returns or sets whether the spline maximum bounded radius value should be used.

Created in NX12.0.0

License requirements to get this property: routing_advanced ("Routing Advanced")

License requirements to set this property: routing_advanced ("Routing Advanced")

unsafe NXOpen.Expression NXOpen.Routing.SplinePathBuilder.BoundedCurvatureRadius
get

Returns the minimum radius allowed for this spline.

Created in NX12.0.0

License requirements: routing_advanced ("Routing Advanced")

unsafe NXOpen.Expression NXOpen.Routing.SplinePathBuilder.BoundedCurvatureRatio
get

Returns the minimum radius allowed for this spline as a ratio to diameter.

Created in NX12.0.0

License requirements: routing_advanced ("Routing Advanced")

unsafe NXOpen.Routing.SplinePathBuilder.DefiningTypes NXOpen.Routing.SplinePathBuilder.DefiningType
getset

Returns or sets the type which specifies the shape of the spline.

See NXOpen.Routing.SplinePathBuilder.DefiningTypes for valid options

Created in NX12.0.0

License requirements to get this property: routing_base ("Routing Basic")

License requirements to set this property: routing_base ("Routing Basic")

unsafe NXOpen.Expression NXOpen.Routing.SplinePathBuilder.MinimumCheckingAllowableRatio
get

Returns the minimum ratio allowed for this spline

Created in NX9.0.1

License requirements: routing_base ("Routing Basic")

unsafe NXOpen.Expression NXOpen.Routing.SplinePathBuilder.MinimumCheckingAllowableValue
get

Returns the minimum radius allowed for this spline.

Created in NX9.0.1

License requirements: routing_base ("Routing Basic")

unsafe NXOpen.Routing.SplinePathBuilder.SplinePathAttributeOptions NXOpen.Routing.SplinePathBuilder.MinimumCheckingMethod
getset

Returns or sets the minimum checking method for this spline.

See NXOpen.Routing.SplinePathBuilder.SplinePathAttributeOptions for valid options

Created in NX9.0.1

License requirements to get this property: routing_base ("Routing Basic")

License requirements to set this property: routing_base ("Routing Basic")

unsafe NXOpen.Routing.SplinePathBuilder.SplinePathRadiusSource NXOpen.Routing.SplinePathBuilder.RadiusSource
getset

Returns or sets the driving expression, value, or attribute of the bounded radius.

Created in NX12.0.0

License requirements to get this property: routing_advanced ("Routing Advanced")

License requirements to set this property: routing_advanced ("Routing Advanced")

unsafe bool NXOpen.Routing.SplinePathBuilder.ShowSplineMinimumRadius
getset

Returns or sets whether the spline minimum radius value should be displayed or not.

Created in NX9.0.1

License requirements to get this property: routing_base ("Routing Basic")

License requirements to set this property: routing_base ("Routing Basic")

unsafe bool NXOpen.Routing.SplinePathBuilder.UseMinimumCheckingValue
getset

Returns or sets whether the spline minimum radius value should be checked or not on this spline.

Created in NX9.0.1

License requirements to get this property: routing_base ("Routing Basic")

License requirements to set this property: routing_base ("Routing Basic")


The documentation for this class was generated from the following file:
Copyright 2019 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.